const visitWithParents = require('unist-util-visit-parents');

function addListMetadata() {
  return ast => {
    visitWithParents(ast, 'list', (listNode, parents) => {
      let depth = 0;
      for (const ancestor of parents) {
        if (ancestor.type === 'list') depth += 1;
      }
      for (let i = 0, n = listNode.children.length; i < n; i++) {
        const child = listNode.children[i];
        child.index = i;
        child.ordered = listNode.ordered;
      }
      listNode.depth = depth;
    });
    return ast;
  };
}

module.exports = addListMetadata;
